/*

  disasmdump v1.66
  copyright (C) bytepointer.com
  disassembler routines copyright (c) 2007-2013 Oleh Yuschuk
  
  View changelist history is globals.h

  LICENSE NOTE: Excluding the source files (c) Oleh Yuschuk (part of the disassembler
  engine), I wrote the routines for these source files either specifically for this
  edition of the project or pulled them from one of my personal code libraries
   whose source code is not currently public. All routines present however form an Open-
  Source project in their entirety.  Disasmdump is free software: you can redistribute it
  and/or modify it under the terms of the GNU General Public License
  version 3 as published by the Free Software Foundation. This program is distributed
  as is, in the hope that it will be useful, but WITHOUT ANY WARRANTY; Glitch or no
  glitch, there is not even an implied warranty of MERCHANTABILITY or FITNESS for any
  endeavor or particular purpose.

  See the GNU General Public License for more details.
  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.
  
  ---
  
  If you have a question, feedback or would like to submit a bug, please visit
  bytepointer.com, or send a direct e-mail to admin@.
  
  Thank you for your interest!

[CHANGELIST HISTORY]

    DATE        VERSION  DESCRIPTION
    ----------  -------  ----------------------------------------------------------------------------------------------------------
    2017-01-16  1.66     -we now retain existing background attributes while changing colors
                         -added version resource
    
    2016-10-19  1.65     fixed bug caused when disassembled opcode column contained symbols (such as ":") that were counted as opcode numbers;
                         this could result in premature truncation of trailing opcode values and misaligned columns, but only when colors were
                         enabled.

    2016-08-17  1.61     minor fixes:
                            -disassembler hex output option -x removed as it is now the default; for base 10 numeric constants, you must use the new option -b 
                            -fixed bug in cmdline help (previously named -o option references should have been -a in help for option -p)
                            -removed dead code for brackets for operator/symbol coloring when brackets previously did not have their own color (no change to existing functionality)
    2016-05-13  1.6      fixed bug in getFileOffsetFromPePointer() where we incorrectly calculated *pdwMaxSizeLeft (size left
                         in corresponding section) based on virtual size rather than size in file; this bug was apparent
                         when dumping UPX sections
    2016-02-15  1.51     renamed cmdline options for consistency with other tools: -a is now -i; -o is now -a
    2016-02-14  1.501    some CRLFs that snuck into source code have been removed (not publicly released)
    2016-02-14  1.5      added support for pe pointers and character columns
    2016-01-25  1.02     verbose summary now details opcodes hilighted for partial instructions
    2016-01-25  1.01     added opcode color (wOpCodePartial) and code to apply it when last instruction is a partial instruction
                         unconditionally uppercase hex bytes in opcodes column
    2016-01-23  1.0      release - initial public version
    
*/
#ifndef _GLOBALS_H_
#define _GLOBALS_H_

//only bring in standard include if not disabled
#ifndef NO_STDINC
#include "stdinc.h"
#endif

//TODO: -o argument should be changed to -a for consistency with bytepatch tool!

//
// Global Definitions
//

//version resource defines for .RC file (NOTE: for these, use normal double-quoted strings, not TCHAR strings)
#define     VER_APP_NAME                    "disasmdump"
#define     VER_APP_NAME_LONG               "Disassembler Dump"
#define     VER_PRODUCT_NAME                VER_APP_NAME_LONG " (" VER_APP_NAME ")"
#define     VER_MODULE_NAME                 VER_APP_NAME ".exe"
#define     VER_APP_ORG_NAME                "bytepointer.com"
#define     VER_APP_DESC                    "32-bit x86 disassembly dump tool"
#define     VER_APP_NUM_MAJOR               1
#define     VER_APP_NUM_MINOR               66
#define     VER_APP_NUM_CENTURY             20
#define     VER_APP_NUM_YEAR                17
#define     VER_APP_NUM_JULIANDAY           0116
#define     VER_APP_NUM_DAYREVISION         0

//build number string is in the format YYMMDDR, however the full version number is represented differently to account for space available in 4
//  WORD values for version resource and is thus in the format MAJOR.MINOR.CCYY.MMDDR where R is 0 to 9 digit for day revision
#define     VER_APP_NUM_BUILD               NUMPASTE(NUMPASTE(VER_APP_NUM_YEAR,VER_APP_NUM_JULIANDAY),VER_APP_NUM_DAYREVISION)
#define     VER_APP_NUM_FULL                VER_APP_NUM_MAJOR,VER_APP_NUM_MINOR,NUMPASTE(VER_APP_NUM_CENTURY,VER_APP_NUM_YEAR),NUMPASTE(VER_APP_NUM_JULIANDAY,VER_APP_NUM_DAYREVISION)
#define     VER_APP_FULL                    STRNUM(VER_APP_NUM_MAJOR) "." STRNUM(VER_APP_NUM_MINOR) " build " STRNUM(VER_APP_NUM_BUILD)
#define     VER_APP_COPYRIGHT_LINE          "copyright (c) " VER_APP_ORG_NAME " " STRNUM(VER_APP_NUM_CENTURY) STRNUM(VER_APP_NUM_YEAR)
#define     VER_COMMENTS                    "freeware / GPL disassembler routines copyright (c) 2007-2013 Oleh Yuschuk"

//version app strings to be used elsewhere in code, but not .RC file
#define     APP_NAME                        TEXT(VER_APP_NAME)
#define     APP_VERSION                     TEXT(STRNUM(VER_APP_NUM_MAJOR)) TEXT(".") TEXT(STRNUM(VER_APP_NUM_MINOR)) TEXT(" build ") TEXT(STRNUM(VER_APP_NUM_BUILD))
#define     APP_DESC_LINE                   TEXT(VER_APP_DESC)
#define     APP_GREETING_LINE               TEXT(VER_APP_NAME_LONG) TEXT(" (") TEXT(VER_APP_NAME) TEXT(") v") APP_VERSION TEXT(" - ") APP_DESC_LINE
#define     APP_COPYRIGHT_LINE              TEXT("copyright (c) ") TEXT(VER_APP_ORG_NAME) TEXT(" ") TEXT(STRNUM(VER_APP_NUM_CENTURY)) TEXT(STRNUM(VER_APP_NUM_YEAR))

#define     APP_MISC_INFO_LINE              TEXT("disassembler routines copyright (c) 2007-2013 Oleh Yuschuk")

                                            //    XXXXXXXXXXXXXXXXXXXXXXXXX 80 CHARACTER COLUMN XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
                                        
#define     GPL_DISCLAIMER_LINES            TEXT("This program is free and open-source software. Please see the headers of the") SZLF \
                                            TEXT("bundled source code for licensing and other detailed information.") SZLF

#endif //_GLOBALS_H_
